/* Problem URL: https://codeforces.com/contest/2146/problem/D1 */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int l, r;
        cin >> l >> r;

        if (r == 0) {
            cout << "0\n0\n";
            continue;
        }

        int n = r + 1;

        vi perm(n, -1);

        set<int> all;
        rep(i, n) {
            all.insert(i);
        }

        int log = 32 - __builtin_clz(r);
        // cout << log << '\n';

        int now = r;
        rep(i, n) {
            if (perm[now] != -1) {
                now--;
                continue;
            }

            int act = 0;
            rep(j, log) {
                if (!((now >> j) & 1)) {
                    act |= 1 << j;
                }
            }

            while (act > 0 && !all.count(act)) {
                act -= 1 << (31 - __builtin_clz(act));
            }

            if (!all.count(act)) {
                now--;
                continue;
            }

            // cout << now << ' ' << act << '\n';

            perm[now] = act;
            perm[act] = now;
            all.erase(now);
            all.erase(act);
            now--;
        }

        rep(i, n) {
            if (perm[i] != -1) {
                continue;
            }

            perm[i] = *prev(all.end());
            all.erase(prev(all.end()));
        }

        ll total = 0;
        rep(i, n) {
            total += perm[i] | i;
        }
        cout << total << '\n';
        cout << perm;
    }
}
